package org.eclipse.jdt.internal.compiler.parser;

package .tmp;

import org.eclipse.jdt.internal.compiler.parser.Parser;
import org.eclipse.jdt.internal.compiler.parser.Scanner;

final class Goal {
  int first;
  
  int[] follow;
  
  int rule;
  
  static int LambdaParameterListRule = 0;
  
  static int IntersectionCastRule = 0;
  
  static int ReferenceExpressionRule = 0;
  
  static int VarargTypeAnnotationsRule = 0;
  
  static int BlockStatementoptRule = 0;
  
  static {
    for (int i = 1; i <= 800; i++) {
      if ("ParenthesizedLambdaParameterList".equals(Parser.name[Parser.non_terminal_index[Parser.lhs[i]]])) {
        LambdaParameterListRule = i;
      } else if ("ParenthesizedCastNameAndBounds".equals(Parser.name[Parser.non_terminal_index[Parser.lhs[i]]])) {
        IntersectionCastRule = i;
      } else if ("ReferenceExpressionTypeArgumentsAndTrunk".equals(Parser.name[Parser.non_terminal_index[Parser.lhs[i]]])) {
        ReferenceExpressionRule = i;
      } else if ("TypeAnnotations".equals(Parser.name[Parser.non_terminal_index[Parser.lhs[i]]])) {
        VarargTypeAnnotationsRule = i;
      } else if ("BlockStatementopt".equals(Parser.name[Parser.non_terminal_index[Parser.lhs[i]]])) {
        BlockStatementoptRule = i;
      } 
    } 
  }
  
  static Goal LambdaParameterListGoal = new Goal(110, new int[] { 110 }, LambdaParameterListRule);
  
  static Goal IntersectionCastGoal = new Goal(24, followSetOfCast(), IntersectionCastRule);
  
  static Goal VarargTypeAnnotationGoal = new Goal(37, new int[] { 113 }, VarargTypeAnnotationsRule);
  
  static Goal ReferenceExpressionGoal = new Goal(11, new int[] { 7 }, ReferenceExpressionRule);
  
  static Goal BlockStatementoptGoal = new Goal(49, new int[0], BlockStatementoptRule);
  
  Goal(int first, int[] follow, int rule) {
    this.first = first;
    this.follow = follow;
    this.rule = rule;
  }
  
  boolean hasBeenReached(int act, int token) {
    if (act == this.rule) {
      int length = this.follow.length;
      if (length == 0)
        return true; 
      for (int i = 0; i < length; i++) {
        if (this.follow[i] == token)
          return true; 
      } 
    } 
    return false;
  }
  
  private static int[] followSetOfCast() {
    return new int[] { 
        22, 36, 34, 35, 
        38, 42, 39, 
        43, 44, 45, 
        46, 47, 48, 
        62, 63, 24 };
  }
}
